

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Optional Chaining &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="OptionalChaining.html#">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="OptionalChaining.html#">Optional Chaining</a><ul>
<li><a class="reference internal" href="OptionalChaining.html#ID246">Optional Chaining as an Alternative to Forced Unwrapping</a></li>
<li><a class="reference internal" href="OptionalChaining.html#ID247">Defining Model Classes for Optional Chaining</a></li>
<li><a class="reference internal" href="OptionalChaining.html#ID248">Accessing Properties Through Optional Chaining</a></li>
<li><a class="reference internal" href="OptionalChaining.html#ID249">Calling Methods Through Optional Chaining</a></li>
<li><a class="reference internal" href="OptionalChaining.html#ID250">Accessing Subscripts Through Optional Chaining</a><ul>
<li><a class="reference internal" href="OptionalChaining.html#ID251">Accessing Subscripts of Optional Type</a></li>
</ul>
</li>
<li><a class="reference internal" href="OptionalChaining.html#ID252">Linking Multiple Levels of Chaining</a></li>
<li><a class="reference internal" href="OptionalChaining.html#ID253">Chaining on Methods with Optional Return Values</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="optional-chaining">
<h1>Optional Chaining<a class="headerlink" href="OptionalChaining.html#optional-chaining" title="Permalink to this headline"></a></h1>
<p><em>Optional chaining</em> is a process for querying and calling properties, methods, and subscripts on an optional that might currently be <code class="docutils literal"><span class="pre">nil</span></code>. If the optional contains a value, the property, method, or subscript call succeeds; if the optional is <code class="docutils literal"><span class="pre">nil</span></code>, the property, method, or subscript call returns <code class="docutils literal"><span class="pre">nil</span></code>. Multiple queries can be chained together, and the entire chain fails gracefully if any link in the chain is <code class="docutils literal"><span class="pre">nil</span></code>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Optional chaining in Swift is similar to messaging <code class="docutils literal"><span class="pre">nil</span></code> in Objective-C, but in a way that works for any type, and that can be checked for success or failure.</p>
</div>
<div class="section" id="ID246">
<h2>Optional Chaining as an Alternative to Forced Unwrapping<a class="headerlink" href="OptionalChaining.html#ID246" title="Permalink to this headline"></a></h2>
<p>You specify optional chaining by placing a question mark (<code class="docutils literal"><span class="pre">?</span></code>) after the optional value on which you wish to call a property, method or subscript if the optional is non-<code class="docutils literal"><span class="pre">nil</span></code>. This is very similar to placing an exclamation mark (<code class="docutils literal"><span class="pre">!</span></code>) after an optional value to force the unwrapping of its value. The main difference is that optional chaining fails gracefully when the optional is <code class="docutils literal"><span class="pre">nil</span></code>, whereas forced unwrapping triggers a runtime error when the optional is <code class="docutils literal"><span class="pre">nil</span></code>.</p>
<p>To reflect the fact that optional chaining can be called on a <code class="docutils literal"><span class="pre">nil</span></code> value, the result of an optional chaining call is always an optional value, even if the property, method, or subscript you are querying returns a nonoptional value. You can use this optional return value to check whether the optional chaining call was successful (the returned optional contains a value), or did not succeed due to a <code class="docutils literal"><span class="pre">nil</span></code> value in the chain (the returned optional value is <code class="docutils literal"><span class="pre">nil</span></code>).</p>
<p>Specifically, the result of an optional chaining call is of the same type as the expected return value, but wrapped in an optional. A property that normally returns an <code class="docutils literal"><span class="pre">Int</span></code> will return an <code class="docutils literal"><span class="pre">Int?</span></code> when accessed through optional chaining.</p>
<p>The next several code snippets demonstrate how optional chaining differs from forced unwrapping and enables you to check for success.</p>
<p>First, two classes called <code class="docutils literal"><span class="pre">Person</span></code> and <code class="docutils literal"><span class="pre">Residence</span></code> are defined:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Person</span> {
</li><li>    <span class="k">var</span> <span class="nv">residence</span>: <span class="nc">Residence</span>?
</li><li>}
</li><li>
</li><li><span class="k">class</span> <span class="nv">Residence</span> {
</li><li>    <span class="k">var</span> <span class="nv">numberOfRooms</span> = <span class="m">1</span>
</li><li>}
</li></ol></pre></div></div>
<p><code class="docutils literal"><span class="pre">Residence</span></code> instances have a single <code class="docutils literal"><span class="pre">Int</span></code> property called <code class="docutils literal"><span class="pre">numberOfRooms</span></code>, with a default value of <code class="docutils literal"><span class="pre">1</span></code>. <code class="docutils literal"><span class="pre">Person</span></code> instances have an optional <code class="docutils literal"><span class="pre">residence</span></code> property of type <code class="docutils literal"><span class="pre">Residence?</span></code>.</p>
<p>If you create a new <code class="docutils literal"><span class="pre">Person</span></code> instance, its <code class="docutils literal"><span class="pre">residence</span></code> property is default initialized to <code class="docutils literal"><span class="pre">nil</span></code>, by virtue of being optional. In the code below, <code class="docutils literal"><span class="pre">john</span></code> has a <code class="docutils literal"><span class="pre">residence</span></code> property value of <code class="docutils literal"><span class="pre">nil</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">john</span> = <span class="nv">Person</span>()
</li></ol></pre></div></div>
<p>If you try to access the <code class="docutils literal"><span class="pre">numberOfRooms</span></code> property of this person’s <code class="docutils literal"><span class="pre">residence</span></code>, by placing an exclamation mark after <code class="docutils literal"><span class="pre">residence</span></code> to force the unwrapping of its value, you trigger a runtime error, because there is no <code class="docutils literal"><span class="pre">residence</span></code> value to unwrap:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">roomCount</span> = <span class="nv">john</span>.<span class="nv">residence</span>!.<span class="nv">numberOfRooms</span>
</li><li><span class="c">// this triggers a runtime error</span>
</li></ol></pre></div></div>
<p>The code above succeeds when <code class="docutils literal"><span class="pre">john.residence</span></code> has a non-<code class="docutils literal"><span class="pre">nil</span></code> value and will set <code class="docutils literal"><span class="pre">roomCount</span></code> to an <code class="docutils literal"><span class="pre">Int</span></code> value containing the appropriate number of rooms. However, this code always triggers a runtime error when <code class="docutils literal"><span class="pre">residence</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>, as illustrated above.</p>
<p>Optional chaining provides an alternative way to access the value of <code class="docutils literal"><span class="pre">numberOfRooms</span></code>. To use optional chaining, use a question mark in place of the exclamation mark:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">roomCount</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">numberOfRooms</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s residence has </span>\<span class="p">(</span><span class="nv">roomCount</span><span class="p">)</span><span class="s"> room(s).&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the number of rooms.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;Unable to retrieve the number of rooms.&quot;</span>
</li></ol></pre></div></div>
<p>This tells Swift to “chain” on the optional <code class="docutils literal"><span class="pre">residence</span></code> property and to retrieve the value of <code class="docutils literal"><span class="pre">numberOfRooms</span></code> if <code class="docutils literal"><span class="pre">residence</span></code> exists.</p>
<p>Because the attempt to access <code class="docutils literal"><span class="pre">numberOfRooms</span></code> has the potential to fail, the optional chaining attempt returns a value of type <code class="docutils literal"><span class="pre">Int?</span></code>, or “optional <code class="docutils literal"><span class="pre">Int</span></code>”. When <code class="docutils literal"><span class="pre">residence</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>, as in the example above, this optional <code class="docutils literal"><span class="pre">Int</span></code> will also be <code class="docutils literal"><span class="pre">nil</span></code>, to reflect the fact that it was not possible to access <code class="docutils literal"><span class="pre">numberOfRooms</span></code>. The optional <code class="docutils literal"><span class="pre">Int</span></code> is accessed through optional binding to unwrap the integer and assign the nonoptional value to the <code class="docutils literal"><span class="pre">roomCount</span></code> variable.</p>
<p>Note that this is true even though <code class="docutils literal"><span class="pre">numberOfRooms</span></code> is a nonoptional <code class="docutils literal"><span class="pre">Int</span></code>. The fact that it is queried through an optional chain means that the call to <code class="docutils literal"><span class="pre">numberOfRooms</span></code> will always return an <code class="docutils literal"><span class="pre">Int?</span></code> instead of an <code class="docutils literal"><span class="pre">Int</span></code>.</p>
<p>You can assign a <code class="docutils literal"><span class="pre">Residence</span></code> instance to <code class="docutils literal"><span class="pre">john.residence</span></code>, so that it no longer has a <code class="docutils literal"><span class="pre">nil</span></code> value:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">john</span>.<span class="nv">residence</span> = <span class="nv">Residence</span>()
</li></ol></pre></div></div>
<p><code class="docutils literal"><span class="pre">john.residence</span></code> now contains an actual <code class="docutils literal"><span class="pre">Residence</span></code> instance, rather than <code class="docutils literal"><span class="pre">nil</span></code>. If you try to access <code class="docutils literal"><span class="pre">numberOfRooms</span></code> with the same optional chaining as before, it will now return an <code class="docutils literal"><span class="pre">Int?</span></code> that contains the default <code class="docutils literal"><span class="pre">numberOfRooms</span></code> value of <code class="docutils literal"><span class="pre">1</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">roomCount</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">numberOfRooms</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s residence has </span>\<span class="p">(</span><span class="nv">roomCount</span><span class="p">)</span><span class="s"> room(s).&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the number of rooms.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;John&#39;s residence has 1 room(s).&quot;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID247">
<h2>Defining Model Classes for Optional Chaining<a class="headerlink" href="OptionalChaining.html#ID247" title="Permalink to this headline"></a></h2>
<p>You can use optional chaining with calls to properties, methods, and subscripts that are more than one level deep. This enables you to drill down into subproperties within complex models of interrelated types, and to check whether it is possible to access properties, methods, and subscripts on those subproperties.</p>
<p>The code snippets below define four model classes for use in several subsequent examples, including examples of multilevel optional chaining. These classes expand upon the <code class="docutils literal"><span class="pre">Person</span></code> and <code class="docutils literal"><span class="pre">Residence</span></code> model from above by adding a <code class="docutils literal"><span class="pre">Room</span></code> and <code class="docutils literal"><span class="pre">Address</span></code> class, with associated properties, methods, and subscripts.</p>
<p>The <code class="docutils literal"><span class="pre">Person</span></code> class is defined in the same way as before:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Person</span> {
</li><li>    <span class="k">var</span> <span class="nv">residence</span>: <span class="nc">Residence</span>?
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">Residence</span></code> class is more complex than before. This time, the <code class="docutils literal"><span class="pre">Residence</span></code> class defines a variable property called <code class="docutils literal"><span class="pre">rooms</span></code>, which is initialized with an empty array of type <code class="docutils literal"><span class="pre">[Room]</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Residence</span> {
</li><li>    <span class="k">var</span> <span class="nv">rooms</span> = [<span class="nv">Room</span>]()
</li><li>    <span class="k">var</span> <span class="nv">numberOfRooms</span>: <span class="nc">Int</span> {
</li><li>        <span class="k">return</span> <span class="nv">rooms</span>.<span class="nv">count</span>
</li><li>    }
</li><li>    <span class="k">subscript</span>(<span class="nv">i</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Room</span> {
</li><li>        <span class="k">get</span> {
</li><li>            <span class="k">return</span> <span class="nv">rooms</span>[<span class="nv">i</span>]
</li><li>        }
</li><li>        <span class="k">set</span> {
</li><li>            <span class="nv">rooms</span>[<span class="nv">i</span>] = <span class="nv">newValue</span>
</li><li>        }
</li><li>    }
</li><li>    <span class="k">func</span> <span class="nv">printNumberOfRooms</span>() {
</li><li>        <span class="nv">print</span>(<span class="s">&quot;The number of rooms is </span>\<span class="p">(</span><span class="nv">numberOfRooms</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li>    }
</li><li>    <span class="k">var</span> <span class="nv">address</span>: <span class="nc">Address</span>?
</li><li>}
</li></ol></pre></div></div>
<p>Because this version of <code class="docutils literal"><span class="pre">Residence</span></code> stores an array of <code class="docutils literal"><span class="pre">Room</span></code> instances, its <code class="docutils literal"><span class="pre">numberOfRooms</span></code> property is implemented as a computed property, not a stored property. The computed <code class="docutils literal"><span class="pre">numberOfRooms</span></code> property simply returns the value of the <code class="docutils literal"><span class="pre">count</span></code> property from the <code class="docutils literal"><span class="pre">rooms</span></code> array.</p>
<p>As a shortcut to accessing its <code class="docutils literal"><span class="pre">rooms</span></code> array, this version of <code class="docutils literal"><span class="pre">Residence</span></code> provides a read-write subscript that provides access to the room at the requested index in the <code class="docutils literal"><span class="pre">rooms</span></code> array.</p>
<p>This version of <code class="docutils literal"><span class="pre">Residence</span></code> also provides a method called <code class="docutils literal"><span class="pre">printNumberOfRooms</span></code>, which simply prints the number of rooms in the residence.</p>
<p>Finally, <code class="docutils literal"><span class="pre">Residence</span></code> defines an optional property called <code class="docutils literal"><span class="pre">address</span></code>, with a type of <code class="docutils literal"><span class="pre">Address?</span></code>. The <code class="docutils literal"><span class="pre">Address</span></code> class type for this property is defined below.</p>
<p>The <code class="docutils literal"><span class="pre">Room</span></code> class used for the <code class="docutils literal"><span class="pre">rooms</span></code> array is a simple class with one property called <code class="docutils literal"><span class="pre">name</span></code>, and an initializer to set that property to a suitable room name:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Room</span> {
</li><li>    <span class="k">let</span> <span class="nv">name</span>: <span class="nc">String</span>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>) { <span class="k">self</span>.<span class="nv">name</span> = <span class="nv">name</span> }
</li><li>}
</li></ol></pre></div></div>
<p>The final class in this model is called <code class="docutils literal"><span class="pre">Address</span></code>. This class has three optional properties of type <code class="docutils literal"><span class="pre">String?</span></code>. The first two properties, <code class="docutils literal"><span class="pre">buildingName</span></code> and <code class="docutils literal"><span class="pre">buildingNumber</span></code>, are alternative ways to identify a particular building as part of an address. The third property, <code class="docutils literal"><span class="pre">street</span></code>, is used to name the street for that address:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Address</span> {
</li><li>    <span class="k">var</span> <span class="nv">buildingName</span>: <span class="nc">String</span>?
</li><li>    <span class="k">var</span> <span class="nv">buildingNumber</span>: <span class="nc">String</span>?
</li><li>    <span class="k">var</span> <span class="nv">street</span>: <span class="nc">String</span>?
</li><li>    <span class="k">func</span> <span class="nv">buildingIdentifier</span>() -&gt; <span class="nc">String</span>? {
</li><li>        <span class="k">if</span> <span class="k">let</span> <span class="nv">buildingNumber</span> = <span class="nv">buildingNumber</span>, <span class="k">let</span> <span class="nv">street</span> = <span class="nv">street</span> {
</li><li>            <span class="k">return</span> <span class="s">&quot;</span>\<span class="p">(</span><span class="nv">buildingNumber</span><span class="p">)</span><span class="s"> </span>\<span class="p">(</span><span class="nv">street</span><span class="p">)</span><span class="s">&quot;</span>
</li><li>        } <span class="k">else</span> <span class="k">if</span> <span class="nv">buildingName</span> != <span class="k">nil</span> {
</li><li>            <span class="k">return</span> <span class="nv">buildingName</span>
</li><li>        } <span class="k">else</span> {
</li><li>            <span class="k">return</span> <span class="k">nil</span>
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">Address</span></code> class also provides a method called <code class="docutils literal"><span class="pre">buildingIdentifier()</span></code>, which has a return type of <code class="docutils literal"><span class="pre">String?</span></code>. This method checks the properties of the address and returns <code class="docutils literal"><span class="pre">buildingName</span></code> if it has a value, or <code class="docutils literal"><span class="pre">buildingNumber</span></code> concatenated with <code class="docutils literal"><span class="pre">street</span></code> if both have values, or <code class="docutils literal"><span class="pre">nil</span></code> otherwise.</p>
</div>
<div class="section" id="ID248">
<h2>Accessing Properties Through Optional Chaining<a class="headerlink" href="OptionalChaining.html#ID248" title="Permalink to this headline"></a></h2>
<p>As demonstrated in <a class="reference internal" href="OptionalChaining.html#ID246"><span class="std std-ref">Optional Chaining as an Alternative to Forced Unwrapping</span></a>, you can use optional chaining to access a property on an optional value, and to check if that property access is successful.</p>
<p>Use the classes defined above to create a new <code class="docutils literal"><span class="pre">Person</span></code> instance, and try to access its <code class="docutils literal"><span class="pre">numberOfRooms</span></code> property as before:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">john</span> = <span class="nv">Person</span>()
</li><li><span class="k">if</span> <span class="k">let</span> <span class="nv">roomCount</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">numberOfRooms</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s residence has </span>\<span class="p">(</span><span class="nv">roomCount</span><span class="p">)</span><span class="s"> room(s).&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the number of rooms.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;Unable to retrieve the number of rooms.&quot;</span>
</li></ol></pre></div></div>
<p>Because <code class="docutils literal"><span class="pre">john.residence</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>, this optional chaining call fails in the same way as before.</p>
<p>You can also attempt to set a property’s value through optional chaining:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">someAddress</span> = <span class="nv">Address</span>()
</li><li><span class="nv">someAddress</span>.<span class="nv">buildingNumber</span> = <span class="s">&quot;29&quot;</span>
</li><li><span class="nv">someAddress</span>.<span class="nv">street</span> = <span class="s">&quot;Acacia Road&quot;</span>
</li><li><span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span> = <span class="nv">someAddress</span>
</li></ol></pre></div></div>
<p>In this example, the attempt to set the <code class="docutils literal"><span class="pre">address</span></code> property of <code class="docutils literal"><span class="pre">john.residence</span></code> will fail, because <code class="docutils literal"><span class="pre">john.residence</span></code> is currently <code class="docutils literal"><span class="pre">nil</span></code>.</p>
<p>The assignment is part of the optional chaining, which means none of the code on the right-hand side of the <code class="docutils literal"><span class="pre">=</span></code> operator is evaluated. In the previous example, it’s not easy to see that <code class="docutils literal"><span class="pre">someAddress</span></code> is never evaluated, because accessing a constant doesn’t have any side effects. The listing below does the same assignment, but it uses a function to create the address. The function prints “Function was called” before returning a value, which lets you see whether the right-hand side of the <code class="docutils literal"><span class="pre">=</span></code> operator was evaluated.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">createAddress</span>() -&gt; <span class="nc">Address</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Function was called.&quot;</span>)
</li><li>
</li><li>    <span class="k">let</span> <span class="nv">someAddress</span> = <span class="nv">Address</span>()
</li><li>    <span class="nv">someAddress</span>.<span class="nv">buildingNumber</span> = <span class="s">&quot;29&quot;</span>
</li><li>    <span class="nv">someAddress</span>.<span class="nv">street</span> = <span class="s">&quot;Acacia Road&quot;</span>
</li><li>
</li><li>    <span class="k">return</span> <span class="nv">someAddress</span>
</li><li>}
</li><li><span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span> = <span class="nv">createAddress</span>()
</li></ol></pre></div></div>
<p>You can tell that the <code class="docutils literal"><span class="pre">createAddress()</span></code> function isn’t called, because nothing is printed.</p>
</div>
<div class="section" id="ID249">
<h2>Calling Methods Through Optional Chaining<a class="headerlink" href="OptionalChaining.html#ID249" title="Permalink to this headline"></a></h2>
<p>You can use optional chaining to call a method on an optional value, and to check whether that method call is successful. You can do this even if that method does not define a return value.</p>
<p>The <code class="docutils literal"><span class="pre">printNumberOfRooms()</span></code> method on the <code class="docutils literal"><span class="pre">Residence</span></code> class prints the current value of <code class="docutils literal"><span class="pre">numberOfRooms</span></code>. Here’s how the method looks:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">printNumberOfRooms</span>() {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;The number of rooms is </span>\<span class="p">(</span><span class="nv">numberOfRooms</span><span class="p">)</span><span class="s">&quot;</span>)
</li><li>}
</li></ol></pre></div></div>
<p>This method does not specify a return type. However, functions and methods with no return type have an implicit return type of <code class="docutils literal"><span class="pre">Void</span></code>, as described in <a class="reference internal" href="Functions.html#ID163"><span class="std std-ref">Functions Without Return Values</span></a>. This means that they return a value of <code class="docutils literal"><span class="pre">()</span></code>, or an empty tuple.</p>
<p>If you call this method on an optional value with optional chaining, the method’s return type will be <code class="docutils literal"><span class="pre">Void?</span></code>, not <code class="docutils literal"><span class="pre">Void</span></code>, because return values are always of an optional type when called through optional chaining. This enables you to use an <code class="docutils literal"><span class="pre">if</span></code> statement to check whether it was possible to call the <code class="docutils literal"><span class="pre">printNumberOfRooms()</span></code> method, even though the method does not itself define a return value. Compare the return value from the <code class="docutils literal"><span class="pre">printNumberOfRooms</span></code> call against <code class="docutils literal"><span class="pre">nil</span></code> to see if the method call was successful:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">printNumberOfRooms</span>() != <span class="k">nil</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;It was possible to print the number of rooms.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;It was not possible to print the number of rooms.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;It was not possible to print the number of rooms.&quot;</span>
</li></ol></pre></div></div>
<p>The same is true if you attempt to set a property through optional chaining. The example above in <a class="reference internal" href="OptionalChaining.html#ID248"><span class="std std-ref">Accessing Properties Through Optional Chaining</span></a> attempts to set an <code class="docutils literal"><span class="pre">address</span></code> value for <code class="docutils literal"><span class="pre">john.residence</span></code>, even though the <code class="docutils literal"><span class="pre">residence</span></code> property is <code class="docutils literal"><span class="pre">nil</span></code>. Any attempt to set a property through optional chaining returns a value of type <code class="docutils literal"><span class="pre">Void?</span></code>, which enables you to compare against <code class="docutils literal"><span class="pre">nil</span></code> to see if the property was set successfully:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> (<span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span> = <span class="nv">someAddress</span>) != <span class="k">nil</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;It was possible to set the address.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;It was not possible to set the address.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;It was not possible to set the address.&quot;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID250">
<h2>Accessing Subscripts Through Optional Chaining<a class="headerlink" href="OptionalChaining.html#ID250" title="Permalink to this headline"></a></h2>
<p>You can use optional chaining to try to retrieve and set a value from a subscript on an optional value, and to check whether that subscript call is successful.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">When you access a subscript on an optional value through optional chaining, you place the question mark <em>before</em> the subscript’s brackets, not after. The optional chaining question mark always follows immediately after the part of the expression that is optional.</p>
</div>
<p>The example below tries to retrieve the name of the first room in the <code class="docutils literal"><span class="pre">rooms</span></code> array of the <code class="docutils literal"><span class="pre">john.residence</span></code> property using the subscript defined on the <code class="docutils literal"><span class="pre">Residence</span></code> class. Because <code class="docutils literal"><span class="pre">john.residence</span></code> is currently <code class="docutils literal"><span class="pre">nil</span></code>, the subscript call fails:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">firstRoomName</span> = <span class="nv">john</span>.<span class="nv">residence</span>?[<span class="m">0</span>].<span class="nv">name</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;The first room name is </span>\<span class="p">(</span><span class="nv">firstRoomName</span><span class="p">)</span><span class="s">.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the first room name.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;Unable to retrieve the first room name.&quot;</span>
</li></ol></pre></div></div>
<p>The optional chaining question mark in this subscript call is placed immediately after <code class="docutils literal"><span class="pre">john.residence</span></code>, before the subscript brackets, because <code class="docutils literal"><span class="pre">john.residence</span></code> is the optional value on which optional chaining is being attempted.</p>
<p>Similarly, you can try to set a new value through a subscript with optional chaining:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">john</span>.<span class="nv">residence</span>?[<span class="m">0</span>] = <span class="nv">Room</span>(<span class="nv">name</span>: <span class="s">&quot;Bathroom&quot;</span>)
</li></ol></pre></div></div>
<p>This subscript setting attempt also fails, because <code class="docutils literal"><span class="pre">residence</span></code> is currently <code class="docutils literal"><span class="pre">nil</span></code>.</p>
<p>If you create and assign an actual <code class="docutils literal"><span class="pre">Residence</span></code> instance to <code class="docutils literal"><span class="pre">john.residence</span></code>, with one or more <code class="docutils literal"><span class="pre">Room</span></code> instances in its <code class="docutils literal"><span class="pre">rooms</span></code> array, you can use the <code class="docutils literal"><span class="pre">Residence</span></code> subscript to access the actual items in the <code class="docutils literal"><span class="pre">rooms</span></code> array through optional chaining:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">johnsHouse</span> = <span class="nv">Residence</span>()
</li><li><span class="nv">johnsHouse</span>.<span class="nv">rooms</span>.<span class="nv">append</span>(<span class="nv">Room</span>(<span class="nv">name</span>: <span class="s">&quot;Living Room&quot;</span>))
</li><li><span class="nv">johnsHouse</span>.<span class="nv">rooms</span>.<span class="nv">append</span>(<span class="nv">Room</span>(<span class="nv">name</span>: <span class="s">&quot;Kitchen&quot;</span>))
</li><li><span class="nv">john</span>.<span class="nv">residence</span> = <span class="nv">johnsHouse</span>
</li><li>
</li><li><span class="k">if</span> <span class="k">let</span> <span class="nv">firstRoomName</span> = <span class="nv">john</span>.<span class="nv">residence</span>?[<span class="m">0</span>].<span class="nv">name</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;The first room name is </span>\<span class="p">(</span><span class="nv">firstRoomName</span><span class="p">)</span><span class="s">.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the first room name.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;The first room name is Living Room.&quot;</span>
</li></ol></pre></div></div>
<div class="section" id="ID251">
<h3>Accessing Subscripts of Optional Type<a class="headerlink" href="OptionalChaining.html#ID251" title="Permalink to this headline"></a></h3>
<p>If a subscript returns a value of optional type—such as the key subscript of Swift’s <code class="docutils literal"><span class="pre">Dictionary</span></code> type—place a question mark <em>after</em> the subscript’s closing bracket to chain on its optional return value:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">testScores</span> = [<span class="s">&quot;Dave&quot;</span>: [<span class="m">86</span>, <span class="m">82</span>, <span class="m">84</span>], <span class="s">&quot;Bev&quot;</span>: [<span class="m">79</span>, <span class="m">94</span>, <span class="m">81</span>]]
</li><li><span class="nv">testScores</span>[<span class="s">&quot;Dave&quot;</span>]?[<span class="m">0</span>] = <span class="m">91</span>
</li><li><span class="nv">testScores</span>[<span class="s">&quot;Bev&quot;</span>]?[<span class="m">0</span>] += <span class="m">1</span>
</li><li><span class="nv">testScores</span>[<span class="s">&quot;Brian&quot;</span>]?[<span class="m">0</span>] = <span class="m">72</span>
</li><li><span class="c">// the &quot;Dave&quot; array is now [91, 82, 84] and the &quot;Bev&quot; array is now [80, 94, 81]</span>
</li></ol></pre></div></div>
<p>The example above defines a dictionary called <code class="docutils literal"><span class="pre">testScores</span></code>, which contains two key-value pairs that map a <code class="docutils literal"><span class="pre">String</span></code> key to an array of <code class="docutils literal"><span class="pre">Int</span></code> values. The example uses optional chaining to set the first item in the <code class="docutils literal"><span class="pre">&quot;Dave&quot;</span></code> array to <code class="docutils literal"><span class="pre">91</span></code>; to increment the first item in the <code class="docutils literal"><span class="pre">&quot;Bev&quot;</span></code> array by <code class="docutils literal"><span class="pre">1</span></code>; and to try to set the first item in an array for a key of <code class="docutils literal"><span class="pre">&quot;Brian&quot;</span></code>. The first two calls succeed, because the <code class="docutils literal"><span class="pre">testScores</span></code> dictionary contains keys for <code class="docutils literal"><span class="pre">&quot;Dave&quot;</span></code> and <code class="docutils literal"><span class="pre">&quot;Bev&quot;</span></code>. The third call fails, because the <code class="docutils literal"><span class="pre">testScores</span></code> dictionary does not contain a key for <code class="docutils literal"><span class="pre">&quot;Brian&quot;</span></code>.</p>
</div>
</div>
<div class="section" id="ID252">
<h2>Linking Multiple Levels of Chaining<a class="headerlink" href="OptionalChaining.html#ID252" title="Permalink to this headline"></a></h2>
<p>You can link together multiple levels of optional chaining to drill down to properties, methods, and subscripts deeper within a model. However, multiple levels of optional chaining do not add more levels of optionality to the returned value.</p>
<p>To put it another way:</p>
<ul class="simple">
<li>If the type you are trying to retrieve is not optional, it will become optional because of the optional chaining.</li>
<li>If the type you are trying to retrieve is <em>already</em> optional, it will not become <em>more</em> optional because of the chaining.</li>
</ul>
<p>Therefore:</p>
<ul class="simple">
<li>If you try to retrieve an <code class="docutils literal"><span class="pre">Int</span></code> value through optional chaining, an <code class="docutils literal"><span class="pre">Int?</span></code> is always returned, no matter how many levels of chaining are used.</li>
<li>Similarly, if you try to retrieve an <code class="docutils literal"><span class="pre">Int?</span></code> value through optional chaining, an <code class="docutils literal"><span class="pre">Int?</span></code> is always returned, no matter how many levels of chaining are used.</li>
</ul>
<p>The example below tries to access the <code class="docutils literal"><span class="pre">street</span></code> property of the <code class="docutils literal"><span class="pre">address</span></code> property of the <code class="docutils literal"><span class="pre">residence</span></code> property of <code class="docutils literal"><span class="pre">john</span></code>. There are <em>two</em> levels of optional chaining in use here, to chain through the <code class="docutils literal"><span class="pre">residence</span></code> and <code class="docutils literal"><span class="pre">address</span></code> properties, both of which are of optional type:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">johnsStreet</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span>?.<span class="nv">street</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s street name is </span>\<span class="p">(</span><span class="nv">johnsStreet</span><span class="p">)</span><span class="s">.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the address.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;Unable to retrieve the address.&quot;</span>
</li></ol></pre></div></div>
<p>The value of <code class="docutils literal"><span class="pre">john.residence</span></code> currently contains a valid <code class="docutils literal"><span class="pre">Residence</span></code> instance. However, the value of <code class="docutils literal"><span class="pre">john.residence.address</span></code> is currently <code class="docutils literal"><span class="pre">nil</span></code>. Because of this, the call to <code class="docutils literal"><span class="pre">john.residence?.address?.street</span></code> fails.</p>
<p>Note that in the example above, you are trying to retrieve the value of the <code class="docutils literal"><span class="pre">street</span></code> property. The type of this property is <code class="docutils literal"><span class="pre">String?</span></code>. The return value of <code class="docutils literal"><span class="pre">john.residence?.address?.street</span></code> is therefore also <code class="docutils literal"><span class="pre">String?</span></code>, even though two levels of optional chaining are applied in addition to the underlying optional type of the property.</p>
<p>If you set an actual <code class="docutils literal"><span class="pre">Address</span></code> instance as the value for <code class="docutils literal"><span class="pre">john.residence.address</span></code>, and set an actual value for the address’s <code class="docutils literal"><span class="pre">street</span></code> property, you can access the value of the <code class="docutils literal"><span class="pre">street</span></code> property through multilevel optional chaining:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">johnsAddress</span> = <span class="nv">Address</span>()
</li><li><span class="nv">johnsAddress</span>.<span class="nv">buildingName</span> = <span class="s">&quot;The Larches&quot;</span>
</li><li><span class="nv">johnsAddress</span>.<span class="nv">street</span> = <span class="s">&quot;Laurel Street&quot;</span>
</li><li><span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span> = <span class="nv">johnsAddress</span>
</li><li>
</li><li><span class="k">if</span> <span class="k">let</span> <span class="nv">johnsStreet</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span>?.<span class="nv">street</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s street name is </span>\<span class="p">(</span><span class="nv">johnsStreet</span><span class="p">)</span><span class="s">.&quot;</span>)
</li><li>} <span class="k">else</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Unable to retrieve the address.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;John&#39;s street name is Laurel Street.&quot;</span>
</li></ol></pre></div></div>
<p>In this example, the attempt to set the <code class="docutils literal"><span class="pre">address</span></code> property of <code class="docutils literal"><span class="pre">john.residence</span></code> will succeed, because the value of <code class="docutils literal"><span class="pre">john.residence</span></code> currently contains a valid <code class="docutils literal"><span class="pre">Address</span></code> instance.</p>
</div>
<div class="section" id="ID253">
<h2>Chaining on Methods with Optional Return Values<a class="headerlink" href="OptionalChaining.html#ID253" title="Permalink to this headline"></a></h2>
<p>The previous example shows how to retrieve the value of a property of optional type through optional chaining. You can also use optional chaining to call a method that returns a value of optional type, and to chain on that method’s return value if needed.</p>
<p>The example below calls the <code class="docutils literal"><span class="pre">Address</span></code> class’s <code class="docutils literal"><span class="pre">buildingIdentifier()</span></code> method through optional chaining. This method returns a value of type <code class="docutils literal"><span class="pre">String?</span></code>. As described above, the ultimate return type of this method call after optional chaining is also <code class="docutils literal"><span class="pre">String?</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">buildingIdentifier</span> = <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span>?.<span class="nv">buildingIdentifier</span>() {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;John&#39;s building identifier is </span>\<span class="p">(</span><span class="nv">buildingIdentifier</span><span class="p">)</span><span class="s">.&quot;</span>)
</li><li>}
</li><li><span class="c">// Prints &quot;John&#39;s building identifier is The Larches.&quot;</span>
</li></ol></pre></div></div>
<p>If you want to perform further optional chaining on this method’s return value, place the optional chaining question mark <em>after</em> the method’s parentheses:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">beginsWithThe</span> =
</li><li>    <span class="nv">john</span>.<span class="nv">residence</span>?.<span class="nv">address</span>?.<span class="nv">buildingIdentifier</span>()?.<span class="nv">hasPrefix</span>(<span class="s">&quot;The&quot;</span>) {
</li><li>    <span class="k">if</span> <span class="nv">beginsWithThe</span> {
</li><li>        <span class="nv">print</span>(<span class="s">&quot;John&#39;s building identifier begins with \&quot;The\&quot;.&quot;</span>)
</li><li>    } <span class="k">else</span> {
</li><li>        <span class="nv">print</span>(<span class="s">&quot;John&#39;s building identifier does not begin with \&quot;The\&quot;.&quot;</span>)
</li><li>    }
</li><li>}
</li><li><span class="c">// Prints &quot;John&#39;s building identifier begins with &quot;The&quot;.&quot;</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">In the example above, you place the optional chaining question mark <em>after</em> the parentheses, because the optional value you are chaining on is the <code class="docutils literal"><span class="pre">buildingIdentifier()</span></code> method’s return value, and not the <code class="docutils literal"><span class="pre">buildingIdentifier()</span></code> method itself.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Deinitialization.html">Deinitialization</a></p>
        <p class="next"><a href="ErrorHandling.html">Error Handling</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
